--SKILLS_WINDOW

local oldRefresh = SKILLS_WINDOW.RefreshSkillInfo

SKILLS_WINDOW.RefreshSkillInfo = function( self )
	oldRefresh( self )
    
    self.availablePointsLabel:SetText(zo_strformat(SI_SKILLS_POINTS_TO_SPEND, self.availablePoints) .. "/" .. (SSP.GetTotalSpentPoints() + self.availablePoints))
end

local oldAddNode = SKILLS_WINDOW.navigationTree.AddNode

SKILLS_WINDOW.navigationTree.AddNode = function( self, template, data, parentNode, selectSound )
	if template == "ZO_IconHeader" then
		return oldAddNode( self, "SSP_Header", data, parentNode, selectSound )
	elseif template == "ZO_SkillsNavigationEntry" then
		return oldAddNode( self, "SSP_NavigationEntry", data, parentNode, selectSound )
	end
	return oldAddNode( self, template, data, parentNode, selectSound )
end

local headerFunction = SKILLS_WINDOW.navigationTree.templateInfo["ZO_IconHeader"].setupFunction

local function TreeHeaderSetup(node, control, skillType, open)
	headerFunction(node, control, skillType, open)
	local label = control:GetNamedChild("PointText")
	label:SetText(SSP.GetTypeSpentPoints( skillType )) 
end
SKILLS_WINDOW.navigationTree:AddTemplate("SSP_Header", TreeHeaderSetup, nil, nil, nil, 0)

local navigationSetup = SKILLS_WINDOW.navigationTree.templateInfo["ZO_SkillsNavigationEntry"].setupFunction
local navigationSelect = SKILLS_WINDOW.navigationTree.templateInfo["ZO_SkillsNavigationEntry"].selectionFunction
local navigationEQ = SKILLS_WINDOW.navigationTree.templateInfo["ZO_SkillsNavigationEntry"].equalityFunction

local function GetMaxRank(skillType)
	if skillType == SKILL_TYPE_AVA or
		skillType == SKILL_TYPE_GUILD or
		skillType == SKILL_TYPE_WORLD then
		return 10
	end
	return 50
end

local function TreeEntrySetup(node, control, data, open)
	navigationSetup(node, control, data, open)
	local label = control:GetNamedChild("PointText")
	if SSP.settings.color then
		local quote = SSP.GetLineSpentPoints( data.skillType, data.skillLineIndex ) / SSP.GetLinePossiblePoints( data.skillType, data.skillLineIndex )
		local red = 255 * (1-quote)
		local green = 255 * quote
		label:SetText(
			string.format("|c%02x%02x%02x%d|r", red, green, 0, SSP.GetLineSpentPoints( data.skillType, data.skillLineIndex ))
			)
		label = control:GetNamedChild("LevelText")
		local _, rank = GetSkillLineInfo(data.skillType, data.skillLineIndex)
		quote = rank / GetMaxRank(data.skillType)
		red = 255 * (1-quote)
		green = 255 * quote
		label:SetText(
			string.format("|c%02x%02x%02x%d|r", red, green, 0, rank)
			)
	else
		label:SetText(SSP.GetLineSpentPoints( data.skillType, data.skillLineIndex ))
		label = control:GetNamedChild("LevelText")
		local _, rank = GetSkillLineInfo(data.skillType, data.skillLineIndex)
		label:SetText(rank)
	end
end

SKILLS_WINDOW.navigationTree:AddTemplate("SSP_NavigationEntry", TreeEntrySetup, navigationSelect, navigationEQ)
